.area FUSE (ABS)
.org 0x3ff
.word ( 0x0260 | 1<<0 | 5<<2 | 1<<7 | 3<<10 )
; reserved_bits | security_off | lvr_1v8 | io_drv_norm | boot_fast

.area OSEG (OVR,DATA)
pwm: .ds 1

.even ; SP must be aligned
stack_start: .ds 1
.area SSEG
stack: .ds 1

; io addresses
clkmd = 0x03
inten = 0x04
intrq = 0x05
tm2c = 0x1C
tm2b = 0x09
tm2s = 0x17
t16m  = 0x06
eoscr = 0x0A
padier = 0x0D
pa = 0x10
pac = 0x11
paph = 0x12
misc = 0x1B
gpcc = 0x1A

; portA.3 -> ivr debug signal
; portA.4 -> pwm output

.area CSEG (CODE,ABS)
.org 0x0000
	GOTO	init

.org 0x0020
	goto	interrupt

init:
	; clock setup (no calibration):
	;set1	clkmd, #4	; enable IHRC
	;mov	a, #(( 0<<5 | 1<<4 | 0<<3 | 1<<2 | 0<<1 | 0<<0 ))
	;mov	clkmd, a	; switch to IHRC/4, WDT off; keep ILRC on

  mov  a, #0x00
  mov  sp, a

	; portA setup:
	mov	a, #0xff
	mov	pac, a

loop:
	; portA setup:
  mov a, #0x00
  mov pa, a
  mov a, #0x01
  mov pa, a
  mov a, #0x02
  mov pa, a
  mov a, #0x04
  mov pa, a
  mov a, #0x08
  mov pa, a
  mov a, #0x10
  mov pa, a
  mov a, #0x20
  mov pa, a
  mov a, #0x40
  mov pa, a
  mov a, #0x80
  mov pa, a
  call push0
	goto loop
	
interrupt:
	reti

.org  0x050
push0:
  call push1
  ret
.org  0x060
push1:
  call push2
  ret
.org  0x070
push2:
  call push3
  ret
.org  0x080
push3:
  call push4
  ret
.org  0x090
push4:
  call push5
  ret
.org  0x0a0
push5:
  call push6
  ret
.org  0x0b0
push6:
  call push7
  ret
.org  0x0c0
push7:
  call push8
  ret
.org  0x0d0
push8:
  call push9
  ret
.org  0x0e0
push9:
  call push10
  ret
.org  0x0f0
push10:
  call push11
  ret
.org  0x100
push11:
  call push12
  ret
.org  0x110
push12:
  call push13
  ret
.org  0x120
push13:
  call push14
  ret
.org  0x130
push14:
  call push15
  ret
.org  0x140
push15:
  ret
